{  AsmIDE by Eric W. Engler
http://www.geocities.com/englere_geo

The contents of this file are subject to the Mozilla Public License
Version 1.1 (the "License"); you may not use this file except in compliance
with the License. You may obtain a copy of the License at
http://www.mozilla.org/MPL/

Software distributed under the License is distributed on an "AS IS" basis,
WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for
the specific language governing rights and limitations under the License.
}

unit frmOptions;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ComCtrls, ExtCtrls, AfDataDispatcher, AfComPort, AfPortControls,
  Dialogs, Registry, Spin;

type
  TOptionsForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    PageControl1: TPageControl;
    tsTerminal: TTabSheet;
    tsAssembler: TTabSheet;
    OKBtn: TButton;
    CancelBtn: TButton;
    OpenDialog1: TOpenDialog;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    AfPortComboBox1: TAfPortComboBox;
    Label13: TLabel;
    lblComOptions: TLabel;
    BtnCOM: TButton;
    tsWytecTools: TTabSheet;
    Label5: TLabel;
    Label6: TLabel;
    Label8: TLabel;
    edtWytecDebugger: TEdit;
    Label7: TLabel;
    edtWytecProgrammer: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    cboWytecBoard: TComboBox;
    Label14: TLabel;
    Label15: TLabel;
    cboMPUtype: TComboBox;
    Label16: TLabel;
    Label17: TLabel;
    cbWytecEnabled: TCheckBox;
    cboWytecCOMPort: TComboBox;
    Label18: TLabel;
    cbEnableCOMPort: TCheckBox;
    Label19: TLabel;
    Label20: TLabel;
    BtnResetCOMPort: TButton;
    Label26: TLabel;
    Label27: TLabel;
    Label28: TLabel;
    Label29: TLabel;
    Label30: TLabel;
    tsAssoc: TTabSheet;
    BtnMakeAssoc: TBitBtn;
    BtnRemoveAssoc: TBitBtn;
    edtExtension: TEdit;
    Label35: TLabel;
    AsmPageControl: TPageControl;
    Panel3: TPanel;
    rgSelectedFamily: TRadioGroup;
    ts6808: TTabSheet;
    ts6809: TTabSheet;
    ts6811: TTabSheet;
    ts6812: TTabSheet;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label12: TLabel;
    Label36: TLabel;
    Label37: TLabel;
    Label38: TLabel;
    edthc11AssemblerPath: TEdit;
    Btn6811Browse1: TButton;
    edthc11HelpFilePath: TEdit;
    Btn6811Browse2: TButton;
    edtas11CommandLine: TEdit;
    Btn6811Browse3: TButton;
    edtas11BatchFile: TEdit;
    Label41: TLabel;
    Label42: TLabel;
    Label43: TLabel;
    Label44: TLabel;
    Label45: TLabel;
    Label40: TLabel;
    Label31: TLabel;
    Label33: TLabel;
    Label39: TLabel;
    Label31a: TLabel;
    Label33a: TLabel;
    Label39a: TLabel;
    edt6809BatchFile: TEdit;
    Btn6809Browse3: TButton;
    edt6809CommandLine: TEdit;
    Btn6809Browse2: TButton;
    edt6809AssemblerPath: TEdit;
    edt6809HelpFilePath: TEdit;
    edt6808BatchFile: TEdit;
    Btn6808Browse3: TButton;
    edt6808CommandLine: TEdit;
    Btn6808Browse2: TButton;
    edt6808AssemblerPath: TEdit;
    edt6808HelpFilePath: TEdit;
    Label46: TLabel;
    Label47: TLabel;
    Label48: TLabel;
    Label49: TLabel;
    Label50: TLabel;
    Label51: TLabel;
    Label46a: TLabel;
    Label47a: TLabel;
    Label48a: TLabel;
    Label49a: TLabel;
    Label50a: TLabel;
    edthc12AssemblerPath: TEdit;
    Btn6812Browse1: TButton;
    edthc12HelpFilePath: TEdit;
    Btn6812Browse2: TButton;
    edtas12BatchFile: TEdit;
    Btn6812Browse3: TButton;
    edtas12CommandLine: TEdit;
    Label52: TLabel;
    Label53: TLabel;
    Label54: TLabel;
    Label55: TLabel;
    Label56: TLabel;
    Label57: TLabel;
    Label58: TLabel;
    Label32: TLabel;
    Label34: TLabel;
    Label59: TLabel;
    Label21: TLabel;
    edtSRecCVT: TEdit;
    tsAuto: TTabSheet;
    tsFunc: TTabSheet;
    Label63: TLabel;
    Label64: TLabel;
    Label65: TLabel;
    edtF2: TEdit;
    Label67: TLabel;
    Label66: TLabel;
    Label68: TLabel;
    Label69: TLabel;
    Label70: TLabel;
    Label71: TLabel;
    Label72: TLabel;
    Label73: TLabel;
    Label74: TLabel;
    Label75: TLabel;
    Label76: TLabel;
    edtF3: TEdit;
    edtF4: TEdit;
    edtF5: TEdit;
    edtF6: TEdit;
    edtF7: TEdit;
    edtF8: TEdit;
    edtF9: TEdit;
    edtF10: TEdit;
    edtF11: TEdit;
    edtF12: TEdit;
    cbReopenLastFile: TCheckBox;
    GroupBox1: TGroupBox;
    Label24: TLabel;
    Label23: TLabel;
    Label25: TLabel;
    Label77: TLabel;
    Label78: TLabel;
    Label60: TLabel;
    Label61: TLabel;
    Label62: TLabel;
    cbEnableAutoLoad: TCheckBox;
    cbEnableAutoGo: TCheckBox;
    cbEnableAutoDump: TCheckBox;
    cbAutosave: TCheckBox;
    cbNoDownloadingFilenamePrompt: TCheckBox;
    Label79: TLabel;
    cbNoAssemblingFilenamePrompt: TCheckBox;
    cbAutoAssemble: TCheckBox;
    Label22: TLabel;
    SpinComPort: TSpinEdit;
    rgDownload: TRadioGroup;
    cbEnableHyperbaud: TCheckBox;

    procedure FormCreate(Sender: TObject);
    procedure BtnCOMClick(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure AfPortComboBox1Change(Sender: TObject);
    procedure cbEnableCOMPortClick(Sender: TObject);
    procedure cbWytecEnabledClick(Sender: TObject);
    procedure cboWytecCOMPortChange(Sender: TObject);
    procedure BtnResetCOMPortClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure BtnRemoveAssocClick(Sender: TObject);
    procedure BtnMakeAssocClick(Sender: TObject);
    procedure Btn6811Browse1Click(Sender: TObject);
    procedure Btn6811Browse2Click(Sender: TObject);
    procedure Btn6811Browse3Click(Sender: TObject);
    procedure Btn6808Browse1Click(Sender: TObject);
    procedure Btn6808Browse2Click(Sender: TObject);
    procedure Btn6808Browse3Click(Sender: TObject);
    procedure Btn6809Browse1Click(Sender: TObject);
    procedure Btn6809Browse2Click(Sender: TObject);
    procedure Btn6809Browse3Click(Sender: TObject);
    procedure Btn6812Browse1Click(Sender: TObject);
    procedure Btn6812Browse2Click(Sender: TObject);
    procedure Btn6812Browse3Click(Sender: TObject);
    procedure rgSelectedFamilyClick(Sender: TObject);
  private
    { Private declarations }
    InFormCreate: Boolean;
    ext: string;

    procedure SetupGUIFromCOMPort;
    function ParseExtension: Boolean;
  public
    { Public declarations }
  end;

var
  OptionsForm: TOptionsForm;

implementation

uses frmMain;

{$R *.DFM}

// This is only executed if the COM port is enabled

procedure TOptionsForm.SetupGUIFromCOMPort;
begin
  //afPortComboBox1.ComPort := mainform.AfComPort1;
  if mainform.AfComPort1.ComNumber = 1 then
    afportcombobox1.itemindex := afportcombobox1.Items.IndexOf('COM 1')
  else if mainform.AfComPort1.ComNumber = 2 then
    afportcombobox1.itemindex := afportcombobox1.Items.IndexOf('COM 2')
  else if mainform.AfComPort1.ComNumber = 3 then
    afportcombobox1.itemindex := afportcombobox1.Items.IndexOf('COM 3')
  else if mainform.AfComPort1.ComNumber = 4 then
    afportcombobox1.itemindex := afportcombobox1.Items.IndexOf('COM 4')
  else if mainform.AfComPort1.ComNumber = 5 then
    afportcombobox1.itemindex := afportcombobox1.Items.IndexOf('COM 5')
  else if mainform.AfComPort1.ComNumber = 6 then
    afportcombobox1.itemindex := afportcombobox1.Items.IndexOf('COM 6')
  else if mainform.AfComPort1.ComNumber = 7 then
    afportcombobox1.itemindex := afportcombobox1.Items.IndexOf('COM 7')
  else if mainform.AfComPort1.ComNumber = 8 then
    afportcombobox1.itemindex := afportcombobox1.Items.IndexOf('COM 8')
  else if mainform.AfComPort1.ComNumber = 9 then
    afportcombobox1.itemindex := afportcombobox1.Items.IndexOf('COM 9');

  // afportcombobox1.itemindex := 0; // select first port available on this PC

  if afportcombobox1.itemindex = -1 then
    lblComOptions.Caption := '<not set>'
  else
    lblComOptions.Caption := mainform.AfComPort1.SettingsStr;
end;

procedure TOptionsForm.FormCreate(Sender: TObject);
begin
  InFormCreate := True;
  PageControl1.ActivePage := tsTerminal;

  if mainform.EnableCOMPort then
    SetupGUIFromCOMPort;

  edt6808AssemblerPath.Text := mainform.iniFile.ReadString('Assembler', '6808AssemblerPath',
    ExtractFilePath(Application.EXEName) + 'as8.exe');
  edt6808HelpFilePath.Text := mainform.iniFile.ReadString('Assembler', '6808HelpPath',
    ExtractFilePath(Application.EXEName) + 'as8.txt');

  edt6809AssemblerPath.Text := mainform.iniFile.ReadString('Assembler', '6809AssemblerPath',
    ExtractFilePath(Application.EXEName) + 'as9.exe');
  edt6809HelpFilePath.Text := mainform.iniFile.ReadString('Assembler', '6809HelpPath',
    ExtractFilePath(Application.EXEName) + 'as9.txt');

  edthc11AssemblerPath.Text := mainform.iniFile.ReadString('Assembler', 'hc11AssemblerPath',
    ExtractFilePath(Application.EXEName) + 'as11.exe');
  edthc11HelpFilePath.Text := mainform.iniFile.ReadString('Assembler', 'hc11HelpPath',
    ExtractFilePath(Application.EXEName) + 'as11.htm');

  edthc12AssemblerPath.Text := mainform.iniFile.ReadString('Assembler', 'hc12AssemblerPath',
    ExtractFilePath(Application.EXEName) + 'as12.exe');
  edthc12HelpFilePath.Text := mainform.iniFile.ReadString('Assembler', 'hc12HelpPath',
    ExtractFilePath(Application.EXEName) + 'as12.htm');

  edt6808CommandLine.Text := mainform.iniFile.ReadString('CommandLine', '6808CommandLine',
    '-lo -s %');
  edt6808BatchFile.Text := mainform.iniFile.ReadString('CommandLine', '6808BatchFile', '');

  edt6809CommandLine.Text := mainform.iniFile.ReadString('CommandLine', '6809CommandLine',
    '-lo -s %');
  edt6809BatchFile.Text := mainform.iniFile.ReadString('CommandLine', '6809BatchFile', '');

  edtas11CommandLine.Text := mainform.iniFile.ReadString('CommandLine', 'as11CommandLine',
    '% -o@.s19 -L@.lst -s');
  edtas11BatchFile.Text := mainform.iniFile.ReadString('CommandLine', 'as11BatchFile', '');

  edtas12CommandLine.Text := mainform.iniFile.ReadString('CommandLine', 'as12CommandLine',
    '% -o@.s19 -L@.lst -s');
  edtas12BatchFile.Text := mainform.iniFile.ReadString('CommandLine', 'as12BatchFile', '');

  if MainForm.SelectedFamily = '6808' then
    rgSelectedFamily.ItemIndex := 0
  else if MainForm.SelectedFamily = '6809' then
    rgSelectedFamily.ItemIndex := 1
  else if MainForm.SelectedFamily = '68hc11' then
    rgSelectedFamily.ItemIndex := 2
  else if MainForm.SelectedFamily = '68hc12' then
    rgSelectedFamily.ItemIndex := 3;

  cbEnableCOMPort.Checked := mainform.EnableCOMPort;
  cbWytecEnabled.Checked := mainform.WytecEnabled;

  cboWytecCOMPort.ItemIndex := cboWytecCOMPort.Items.IndexOf(mainform.WytecCOMPort);
  edtWytecDebugger.Text := mainform.WytecDebuggerPath;
  if not FileExists(mainform.WytecDebuggerPath) then
    cbWytecEnabled.Checked := False;
  edtWytecProgrammer.Text := mainform.WytecProgrammerPath;
  cboWytecBoard.ItemIndex := cboWytecBoard.Items.IndexOf(mainform.WytecBoard);
  cboMPUtype.ItemIndex := cboMPUtype.Items.IndexOf(mainform.WytecMPUType);

  edtExtension.Text := mainform.iniFile.ReadString('Assembler Extension', 'ext', '.asm');
  edtSRecCVT.Text := mainform.iniFile.ReadString('SRecCVT', 'CommandLine', '');

  rgDownload.ItemIndex := mainform.iniFile.ReadInteger('Download6812', 'option', 0);

  SpinCOMPort.Value := mainform.iniFile.ReadInteger('BinLoad', 'COM Port', 1);

  cbEnableAutoLoad.Checked := mainform.iniFile.ReadBool('AutoFunctions', 'EnableLoad', True);
  cbEnableAutoGo.Checked := mainform.iniFile.ReadBool('AutoFunctions', 'EnableGo', True);
  cbEnableAutoDump.Checked := mainform.iniFile.ReadBool('AutoFunctions', 'EnableDump', True);

  edtF2.Text := mainform.iniFile.ReadString('TerminalFunctionKeys', 'F2', 'FBULK');
  edtF3.Text := mainform.iniFile.ReadString('TerminalFunctionKeys', 'F3', 'FPROG ;b');
  edtF4.Text := mainform.iniFile.ReadString('TerminalFunctionKeys', 'F4', 'LOAD');
  edtF5.Text := mainform.iniFile.ReadString('TerminalFunctionKeys', 'F5', 'g 2000');
  edtF6.Text := mainform.iniFile.ReadString('TerminalFunctionKeys', 'F6', '');
  edtF7.Text := mainform.iniFile.ReadString('TerminalFunctionKeys', 'F7', '');
  edtF8.Text := mainform.iniFile.ReadString('TerminalFunctionKeys', 'F8', '');
  edtF9.Text := mainform.iniFile.ReadString('TerminalFunctionKeys', 'F9', '');
  edtF10.Text := mainform.iniFile.ReadString('TerminalFunctionKeys', 'F10', '');
  edtF11.Text := mainform.iniFile.ReadString('TerminalFunctionKeys', 'F11', '');
  edtF12.Text := mainform.iniFile.ReadString('TerminalFunctionKeys', 'F12', '');

  cbReopenLastFile.Checked := mainform.iniFile.ReadBool('CurrentFile', 'ReopenLastFile', True);
  cbEnableHyperbaud.Checked := mainform.iniFile.ReadBool('Toolbar', 'EnableHyperbaud', True);
  cbNoDownloadingFileNamePrompt.Checked := mainform.iniFile.ReadBool('AutoFunctions', 'NoDownloadingFileNamePrompt', True);
  cbNoAssemblingFilenamePrompt.Checked := mainform.iniFile.ReadBool('AutoFunctions', 'NoAssemblingFileNamePrompt', True);
  cbAutosave.Checked := mainform.iniFile.ReadBool('AutoFunctions', 'Autosave', True);
  cbAutoAssemble.Checked := mainform.iniFile.ReadBool('AutoFunctions', 'AutoAssemble', True);

  InFormCreate := False;
end;

procedure TOptionsForm.BtnCOMClick(Sender: TObject);
begin
  mainform.AfComPort1.ExecuteConfigDialog;
  lblComOptions.Caption := mainform.AfComPort1.SettingsStr;
end;

procedure TOptionsForm.OKBtnClick(Sender: TObject);
var
  Baud: string;
  Databits: integer;
  Stopbits, Parity, FlowControl: string;
begin
  mainform.iniFile.WriteString('Assembler', '6808AssemblerPath', edt6808AssemblerPath.Text);
  mainform.iniFile.WriteString('Assembler', '6808HelpPath', edt6808HelpFilePath.Text);
  mainform.iniFile.WriteString('CommandLine', '6808CommandLine', edt6808CommandLine.Text);
  mainform.iniFile.WriteString('CommandLine', '6808BatchFile', edt6808BatchFile.Text);

  mainform.iniFile.WriteString('Assembler', '6809AssemblerPath', edt6809AssemblerPath.Text);
  mainform.iniFile.WriteString('Assembler', '6809HelpPath', edt6809HelpFilePath.Text);
  mainform.iniFile.WriteString('CommandLine', '6809CommandLine', edt6809CommandLine.Text);
  mainform.iniFile.WriteString('CommandLine', '6809BatchFile', edt6809BatchFile.Text);

  mainform.iniFile.WriteString('Assembler', 'hc11AssemblerPath', edthc11AssemblerPath.Text);
  mainform.iniFile.WriteString('Assembler', 'hc11HelpPath', edthc11HelpFilePath.Text);
  mainform.iniFile.WriteString('CommandLine', 'as11CommandLine', edtas11CommandLine.Text);
  mainform.iniFile.WriteString('CommandLine', 'as11BatchFile', edtas11BatchFile.Text);

  mainform.iniFile.WriteString('Assembler', 'hc12AssemblerPath', edthc12AssemblerPath.Text);
  mainform.iniFile.WriteString('Assembler', 'hc12HelpPath', edthc12HelpFilePath.Text);
  mainform.iniFile.WriteString('CommandLine', 'as12CommandLine', edtas12CommandLine.Text);
  mainform.iniFile.WriteString('CommandLine', 'as12BatchFile', edtas12BatchFile.Text);

  if rgDownload.ItemIndex = 2 then
  begin
    // Pluto needs exclusive use of COM port
    mainform.EnableCOMPort := false;
    mainform.afComPort1.Active := false;
  end;

  if mainform.EnableCOMPort then
  begin
   //ShowMessage(mainform.AfComPort1.SettingsStr);
    case mainform.AfComPort1.BaudRate of
      br1200: Baud := '1200';
      br2400: Baud := '2400';
      br4800: Baud := '4800';
      br9600: Baud := '9600';
      br19200: Baud := '19200';
      br38400: Baud := '38400';
      br57600: Baud := '57600';
      br115200: Baud := '115200';
    end;
    DataBits := 8;
    case mainform.AfComPort1.Databits of
      db4: Databits := 4;
      db5: Databits := 5;
      db6: Databits := 6;
      db7: Databits := 7;
      db8: Databits := 8;
    end;
    case mainform.AfComPort1.Stopbits of
      sbOne: Stopbits := '1';
      sbOneAndHalf: Stopbits := '1.5';
      sbTwo: Stopbits := '2';
    end;
    case mainform.AfComPort1.Parity of
      paNone: Parity := 'None';
      paOdd: Parity := 'Odd';
      paEven: Parity := 'Even';
      paMark: Parity := 'Mark';
      paSpace: Parity := 'Space';
    end;
    case mainform.AfComPort1.FlowControl of
      fwNone: FlowControl := 'None';
      fwXOnXOff: FlowControl := 'XOnXOff';
      fwRtsCts: FlowControl := 'RtsCts';
      fwDtrDsr: FlowControl := 'DtrDsr';
    end;

    mainform.iniFile.WriteString('COM PORT', 'Baud Rate', Baud);
    mainform.iniFile.WriteInteger('COM PORT', 'COM Number', mainform.AfComPort1.ComNumber);
    mainform.iniFile.WriteInteger('COM PORT', 'Databits', Databits);
    mainform.iniFile.WriteString('COM PORT', 'Stopbits', Stopbits);
    mainform.iniFile.WriteString('COM PORT', 'Parity', Parity);
    mainform.iniFile.WriteString('COM PORT', 'FlowControl', FlowControl);
  end;
  cbEnableCOMPortClick(self);

  if rgSelectedFamily.ItemIndex = 0 then
  begin
    mainform.iniFile.WriteString('Assembler', 'SelectedFamily', '6808');
    MainForm.SelectedFamily := '6808';
  end
  else if rgSelectedFamily.ItemIndex = 1 then
  begin
    mainform.iniFile.WriteString('Assembler', 'SelectedFamily', '6809');
    MainForm.SelectedFamily := '6809';
  end
  else if rgSelectedFamily.ItemIndex = 2 then
  begin
    mainform.iniFile.WriteString('Assembler', 'SelectedFamily', '68hc11');
    MainForm.SelectedFamily := '68hc11';
  end
  else if rgSelectedFamily.ItemIndex = 3 then
  begin
    mainform.iniFile.WriteString('Assembler', 'SelectedFamily', '68hc12');
    MainForm.SelectedFamily := '68hc12';
  end;

  mainform.iniFile.WriteBool('Wytec', 'Enabled', cbWytecEnabled.Checked);
  mainform.iniFile.WriteString('Wytec', 'COM Port', cboWytecCOMPort.Text);
  mainform.iniFile.WriteString('Wytec', 'DebuggerPath', edtWytecDebugger.Text);
  mainform.iniFile.WriteString('Wytec', 'ProgrammerPath', edtWytecProgrammer.Text);
  mainform.iniFile.WriteString('Wytec', 'Board', cboWytecBoard.Text);
  mainform.iniFile.WriteString('Wytec', 'MPU', cboMPUtype.Text);

  mainform.WytecEnabled := cbWytecEnabled.Checked;
  mainform.WytecCOMPort := cboWytecCOMPort.Text;
  mainform.WytecDebuggerPath := edtWytecDebugger.Text;
  mainform.WytecProgrammerPath := edtWytecProgrammer.Text;
  mainform.WytecBoard := cboWytecBoard.Text;
  mainform.WytecMPUtype := cboMPUtype.Text;

  mainform.iniFile.WriteString('Assembler Extension', 'ext', edtExtension.Text);
  mainform.iniFile.WriteString('SRecCVT', 'CommandLine', edtSRecCVT.Text);
  mainform.iniFile.WriteInteger('Download6812', 'option', rgDownload.ItemIndex);
  mainform.iniFile.WriteInteger('BinLoad', 'COM Port', SpinCOMPort.Value);

  mainform.iniFile.WriteBool('AutoFunctions', 'EnableLoad', cbEnableAutoLoad.Checked);
  mainform.iniFile.WriteBool('AutoFunctions', 'EnableGo', cbEnableAutoGo.Checked);
  mainform.iniFile.WriteBool('AutoFunctions', 'EnableDump', cbEnableAutoDump.Checked);

  mainform.iniFile.WriteString('TerminalFunctionKeys', 'F2', edtF2.Text);
  mainform.iniFile.WriteString('TerminalFunctionKeys', 'F3', edtF3.Text);
  mainform.iniFile.WriteString('TerminalFunctionKeys', 'F4', edtF4.Text);
  mainform.iniFile.WriteString('TerminalFunctionKeys', 'F5', edtF5.Text);
  mainform.iniFile.WriteString('TerminalFunctionKeys', 'F6', edtF6.Text);
  mainform.iniFile.WriteString('TerminalFunctionKeys', 'F7', edtF7.Text);
  mainform.iniFile.WriteString('TerminalFunctionKeys', 'F8', edtF8.Text);
  mainform.iniFile.WriteString('TerminalFunctionKeys', 'F9', edtF9.Text);
  mainform.iniFile.WriteString('TerminalFunctionKeys', 'F10', edtF10.Text);
  mainform.iniFile.WriteString('TerminalFunctionKeys', 'F11', edtF11.Text);
  mainform.iniFile.WriteString('TerminalFunctionKeys', 'F12', edtF12.Text);
  mainform.F2String := edtF2.Text;
  mainform.F3String := edtF3.Text;
  mainform.F4String := edtF4.Text;
  mainform.F5String := edtF5.Text;
  mainform.F6String := edtF6.Text;
  mainform.F7String := edtF7.Text;
  mainform.F8String := edtF8.Text;
  mainform.F9String := edtF9.Text;
  mainform.F10String := edtF10.Text;
  mainform.F11String := edtF11.Text;
  mainform.F12String := edtF12.Text;

  mainform.iniFile.WriteBool('CurrentFile', 'ReopenLastFile', cbReopenLastFile.Checked);
  mainform.iniFile.WriteBool('Toolbar', 'EnableHyperbaud', cbEnableHyperbaud.Checked);
  mainform.iniFile.WriteBool('AutoFunctions', 'NoDownloadingFileNamePrompt', cbNoDownloadingFilenamePrompt.Checked);
  mainform.iniFile.WriteBool('AutoFunctions', 'NoAssemblingFileNamePrompt', cbNoAssemblingFileNamePrompt.Checked);
  mainform.iniFile.WriteBool('AutoFunctions', 'AutoAssemble', cbAutoAssemble.Checked);
  mainform.iniFile.WriteBool('AutoFunctions', 'Autosave', cbAutosave.Checked);
end;

procedure TOptionsForm.AfPortComboBox1Change(Sender: TObject);
begin
end;

// We normally don't take any action until OK is pressed, but in this case
// we need to disable the COM port right away in case the user wants to
// use the Wytec port. Our WytecConflict check also requires this change
// to take effect right away.

procedure TOptionsForm.cbEnableCOMPortClick(Sender: TObject);
begin
  if InFormCreate then
    Exit;
  if cbEnableCOMPort.Checked and (rgDownload.ItemIndex = 0) then
  begin
    if mainform.AfComPort1.ComNumber = 0 then
    begin
      MessageDlg('Please select a COM port', mtError, [mbOK], 0);
      cbEnableCOMPort.Checked := False;
      Exit;
    end;
    // Enable the COM port
    mainform.EnableCOMPort := True;
    mainform.iniFile.WriteBool('COM PORT', 'EnableCOMPort', True);
    mainform.iniFile.WriteInteger('COM PORT', 'COM Number', mainform.AfComPort1.ComNumber);
//    lblComOptions.Caption := mainform.AfComPort1.SettingsStr;
    mainform.SetupCOMPort;
    SetupGUIFromCOMPort;

    mainform.AfDataDispatcher1.Clear;
    mainform.AfComPort1.Open;
    mainform.afDataTerminal1.Enabled := True;
    mainform.tsTerminal.TabVisible := True;

    if cbWytecEnabled.Checked and mainform.WytecConflict then
    begin
      MessageDlg('Disabling Wytec tools to allow Terminal Window to use COM port', mtWarning, [mbOK], 0);
      cbWytecEnabled.Checked := False;
      mainform.iniFile.WriteBool('Wytec', 'Enabled', False);
    end;
  end
  else
  begin
    // Disable the COM Port
    mainform.AfComPort1.Close;
    mainform.afDataTerminal1.Enabled := False;
    mainform.tsTerminal.TabVisible := False;
    mainform.EnableCOMPort := False;
    mainform.iniFile.WriteBool('COM PORT', 'EnableCOMPort', False);
  end;
end;

procedure TOptionsForm.cbWytecEnabledClick(Sender: TObject);
begin
  if InFormCreate then
    Exit;
  if cbWytecEnabled.Checked and (mainform.EnableCOMPort) then
  begin
    if mainform.WytecConflict then
    begin
      MessageDlg('Disabling terminal window to allow Wytec tools to work', mtWarning, [mbOK], 0);
      // Disable the Terminal COM Port
      cbEnableCOMPort.Checked := False;
      mainform.AfComPort1.Close;
      mainform.EnableCOMPort := False;
      mainform.afDataTerminal1.Enabled := False;
      mainform.tsTerminal.TabVisible := False;
      mainform.iniFile.WriteBool('COM PORT', 'EnableCOMPort', False);
    end;
  end;

  if cbWytecEnabled.Checked then
  begin
    mainform.iniFile.WriteBool('Wytec', 'Enabled', True);
    mainform.WytecEnabled := True;
  end
  else
  begin
    mainform.iniFile.WriteBool('Wytec', 'Enabled', False);
    mainform.WytecEnabled := False;
  end;
end;

procedure TOptionsForm.cboWytecCOMPortChange(Sender: TObject);
begin
  mainform.iniFile.WriteString('Wytec', 'COM Port', cboWytecCOMPort.Text);
  mainform.WytecCOMPort := cboWytecCOMPort.Text;
  cbWytecEnabledClick(self); // look for a com port conflict
end;

procedure TOptionsForm.BtnResetCOMPortClick(Sender: TObject);
begin
  mainform.iniFile.WriteInteger('COM PORT', 'COM Number', 1);
  mainform.iniFile.WriteString('COM PORT', 'Baud Rate', '9600');
  mainform.iniFile.WriteInteger('COM PORT', 'Databits', 8);
  mainform.iniFile.WriteString('COM PORT', 'Stopbits', '1');
  mainform.iniFile.WriteString('COM PORT', 'Parity', 'None');
  mainform.iniFile.WriteString('COM PORT', 'FlowControl', 'XOnXOff');
  mainform.SetupCOMPort;
  SetupGUIFromCOMPort;
  cbWytecEnabled.Checked := False;
  cbWytecEnabledClick(self);
end;

procedure TOptionsForm.Button1Click(Sender: TObject);
begin
  showmessage(inttostr(mainform.AfComPort1.ComNumber));
end;

procedure TOptionsForm.BtnRemoveAssocClick(Sender: TObject);
var
  Reg: TRegistry;
begin
  if not ParseExtension then
    Exit;

  Reg := TRegistry.Create;
  with Reg do
  begin
    RootKey := HKEY_CLASSES_ROOT;
    DeleteKey(ext);
    DeleteKey('AsmIDE Assembler File');
    Free;
  end;
  MessageDlg('Done', mtInformation, [mbOK], 0);
end;

function TOptionsForm.ParseExtension: Boolean;
begin
  result := False;

  ext := edtExtension.Text;
  if Length(ext) < 1 then
  begin
    MessageDlg('You must specify an Extension', mtError, [mbOK], 0);
    Exit;
  end;

  if Length(ext) > 4 then
  begin
    MessageDlg('Extension is too long', mtError, [mbOK], 0);
    Exit;
  end;

  if ext[1] <> '.' then
    ext := '.' + ext; // must begin with period

  mainform.iniFile.WriteString('Assembler Extension', 'ext', edtExtension.Text);
  Result := True;
end;

procedure TOptionsForm.BtnMakeAssocClick(Sender: TObject);
var
  Reg: TRegistry;

begin
  if not ParseExtension then
    Exit;

  Reg := TRegistry.Create;
  with Reg do
  begin
    RootKey := HKEY_CLASSES_ROOT;
    OpenKey(ext, True);
    WriteString('', 'AsmIDE' + ext);
    CloseKey;
    OpenKey('AsmIDE' + ext, True);
    WriteString('', 'AsmIDE Assembler File');
    CloseKey;
    OpenKey('AsmIDE' + ext + '\Shell\Open\Command', True);
    // Specify the pathname of AsmIDE:
    WriteString('', '"' + ParamStr(0) + '"' + ' "%1"');
    CloseKey;
  end;
  MessageDlg('Done', mtInformation, [mbOK], 0);
end;

procedure TOptionsForm.Btn6808Browse1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := GetCurrentDir;
  OpenDialog1.Filter := 'Executable files|*.exe|All files|*.*';
  if OpenDialog1.Execute then
  begin
    edt6808AssemblerPath.Text := OpenDialog1.Filename;
  end;
end;

procedure TOptionsForm.Btn6808Browse2Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := GetCurrentDir;
  OpenDialog1.Filter := 'All Files|*.*';
  if OpenDialog1.Execute then
  begin
    edt6808HelpFilePath.Text := OpenDialog1.Filename;
  end;
end;

procedure TOptionsForm.Btn6808Browse3Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := GetCurrentDir;
  OpenDialog1.Filter := 'BAT Files|*.bat|CMD Files|*.cmd|All Files|*.*';
  if OpenDialog1.Execute then
  begin
    edt6808BatchFile.Text := OpenDialog1.Filename;
  end;
end;

procedure TOptionsForm.Btn6809Browse1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := GetCurrentDir;
  OpenDialog1.Filter := 'Executable files|*.exe|All files|*.*';
  if OpenDialog1.Execute then
  begin
    edt6809AssemblerPath.Text := OpenDialog1.Filename;
  end;
end;

procedure TOptionsForm.Btn6809Browse2Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := GetCurrentDir;
  OpenDialog1.Filter := 'All Files|*.*';
  if OpenDialog1.Execute then
  begin
    edt6809HelpFilePath.Text := OpenDialog1.Filename;
  end;
end;

procedure TOptionsForm.Btn6809Browse3Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := GetCurrentDir;
  OpenDialog1.Filter := 'BAT Files|*.bat|CMD Files|*.cmd|All Files|*.*';
  if OpenDialog1.Execute then
  begin
    edt6809BatchFile.Text := OpenDialog1.Filename;
  end;
end;

procedure TOptionsForm.Btn6811Browse1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := GetCurrentDir;
  OpenDialog1.Filter := 'Executable files|*.exe|All files|*.*';
  if OpenDialog1.Execute then
  begin
    edthc11AssemblerPath.Text := OpenDialog1.Filename;
  end;
end;

procedure TOptionsForm.Btn6811Browse2Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := GetCurrentDir;
  OpenDialog1.Filter := 'All Files|*.*';
  if OpenDialog1.Execute then
  begin
    edthc11HelpFilePath.Text := OpenDialog1.Filename;
  end;
end;

procedure TOptionsForm.Btn6811Browse3Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := GetCurrentDir;
  OpenDialog1.Filter := 'BAT Files|*.bat|CMD Files|*.cmd|All Files|*.*';
  if OpenDialog1.Execute then
  begin
    edtas11BatchFile.Text := OpenDialog1.Filename;
  end;
end;

procedure TOptionsForm.Btn6812Browse1Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := GetCurrentDir;
  OpenDialog1.Filter := 'Executable files|*.exe|All files|*.*';
  if OpenDialog1.Execute then
  begin
    edthc12AssemblerPath.Text := OpenDialog1.Filename;
  end;
end;

procedure TOptionsForm.Btn6812Browse2Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := GetCurrentDir;
  OpenDialog1.Filter := 'All Files|*.*';
  if OpenDialog1.Execute then
  begin
    edthc12HelpFilePath.Text := OpenDialog1.Filename;
  end;
end;

procedure TOptionsForm.Btn6812Browse3Click(Sender: TObject);
begin
  OpenDialog1.InitialDir := GetCurrentDir;
  OpenDialog1.Filter := 'BAT Files|*.bat|CMD Files|*.cmd|All Files|*.*';
  if OpenDialog1.Execute then
  begin
    edtas12BatchFile.Text := OpenDialog1.Filename;
  end;
end;

procedure TOptionsForm.rgSelectedFamilyClick(Sender: TObject);
begin
  if rgSelectedFamily.ItemIndex = 0 then
    AsmPageControl.ActivePage := ts6808
  else if rgSelectedFamily.ItemIndex = 1 then
    AsmPageControl.ActivePage := ts6809
  else if rgSelectedFamily.ItemIndex = 2 then
    AsmPageControl.ActivePage := ts6811
  else if rgSelectedFamily.ItemIndex = 3 then
    AsmPageControl.ActivePage := ts6812;
end;

end.

